package org.drools.cep;

import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import org.drools.model.Query;

public class Rules90ED6323DBE10CD97A34DF0D2D82DF4B implements org.drools.model.Model {

    public final static java.time.format.DateTimeFormatter DATE_TIME_FORMATTER = java.time.format.DateTimeFormatter.ofPattern(org.drools.core.util.DateUtils.getDateFormatMask(),
                                                                                                                              java.util.Locale.ENGLISH);

    @Override
    public String getName() {
        return "org.drools.cep";
    }

    @Override
    public java.util.List<org.drools.model.EntryPoint> getEntryPoints() {
        return java.util.Collections.emptyList();
    }

    @Override
    public java.util.List<org.drools.model.Global> getGlobals() {
        return globals;
    }

    @Override
    public java.util.List<org.drools.model.TypeMetaData> getTypeMetaDatas() {
        return typeMetaDatas;
    }

    public static final org.drools.model.Query1Def<java.lang.String> queryDef_stockTickEventQuery = D.query("org.drools.cep",
                                                                                                            "stockTickEventQuery",
                                                                                                            java.lang.String.class,
                                                                                                            "companyName");

    java.util.List<org.drools.model.Global> globals = java.util.Collections.emptyList();

    java.util.List<org.drools.model.TypeMetaData> typeMetaDatas = java.util.Collections.emptyList();

    /**
     * With the following expression ID:
     * org.drools.modelcompiler.builder.generator.DRLIdGenerator@24aa1547
     */
    @Override
    public java.util.List<org.drools.model.Rule> getRules() {
        return rules;
    }

    public java.util.List<org.drools.model.Rule> getRulesList() {
        return java.util.Arrays.asList(Rules90ED6323DBE10CD97A34DF0D2D82DF4BRuleMethods0.rule_StockAverage(),
                                       Rules90ED6323DBE10CD97A34DF0D2D82DF4BRuleMethods0.rule_StockLog());
    }

    java.util.List<org.drools.model.Rule> rules = getRulesList();

    final Query query_stockTickEventQuery = query_stockTickEventQuery();

    @Override
    public java.util.List<org.drools.model.Query> getQueries() {
        return queries;
    }

    private org.drools.model.Query query_stockTickEventQuery() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                              DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                              "stock");
        org.drools.model.Query stockTickEventQuery_build = queryDef_stockTickEventQuery.build(D.pattern(var_stock).expr("0A137729CEB27E8D42587217F18E1BCF",
                                                                                                                        queryDef_stockTickEventQuery.getArg1(),
                                                                                                                        (org.kie.hacep.sample.kjar.StockTickEvent _this, java.lang.String companyName) -> org.drools.modelcompiler.util.EvaluationUtil.areNullSafeEquals(_this.getCompany(),
                                                                                                                                                                                                                                                                         companyName),
                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                        DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                        (org.kie.hacep.sample.kjar.StockTickEvent _this) -> _this.getCompany(),
                                                                                                                                        (java.lang.String companyName) -> companyName,
                                                                                                                                        java.lang.String.class),
                                                                                                                        D.reactOn("company")));
        return stockTickEventQuery_build;
    }

    java.util.List<org.drools.model.Query> queries = new java.util.ArrayList<>();

    {
        queries.add(query_stockTickEventQuery);
    }
}
