package org.drools.cep;

import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.Rules90ED6323DBE10CD97A34DF0D2D82DF4B.*;

public class Rules90ED6323DBE10CD97A34DF0D2D82DF4BRuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_GENERATED_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                             DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                             "GENERATED_$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         org.drools.cep.P22.LambdaExtractor223206EC4450435CC071E9CA3F436D41.INSTANCE,
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_GENERATED_$pattern_StockTickEvent$1$).expr("E44016C0D11BC5C44AC48D88E9FD4D6A",
                                                                                                                                        var_$name,
                                                                                                                                        org.drools.cep.P13.LambdaPredicate1362BAC55FA2B1B05C680A30C1BB9FD0.INSTANCE,
                                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                                        DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                                        org.drools.cep.P9F.LambdaExtractor9FA39398B40C2CA22C1278B51F3AF7FC.INSTANCE,
                                                                                                                                                        org.drools.cep.P8E.LambdaExtractor8E3D452883EFC62232A6AD35329BF221.INSTANCE,
                                                                                                                                                        java.lang.String.class),
                                                                                                                                        D.reactOn("company")).bind(var_$p,
                                                                                                                                                                   org.drools.cep.P57.LambdaExtractor579389CB194C1D7D4783AAD4DC5DAC70.INSTANCE,
                                                                                                                                                                   D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(org.drools.cep.PE9.LambdaConsequenceE90321B5FED50CDFE08D98FC3D011812.INSTANCE));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadata90ED6323DBE10CD97A34DF0D2D82DF4B.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(org.drools.cep.PC3.LambdaConsequenceC361644A11DA9F053CC8E61BAA0BB4BF.INSTANCE));
        return rule;
    }
}
